package net.mcreator.puzzle_code.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.WidgetSprites;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.puzzle_code.world.inventory.CustomEffectBlockGUI3Menu;
import net.mcreator.puzzle_code.procedures.ReturnRangeProcedure;
import net.mcreator.puzzle_code.procedures.EffectBlockGUIPage2ValueDisplayConditionProcedure;
import net.mcreator.puzzle_code.procedures.EffectBlockGUIPage2TextProcedure;
import net.mcreator.puzzle_code.procedures.EffectBlockGUIPage2LogicDisplayTrueProcedure;
import net.mcreator.puzzle_code.procedures.EffectBlockGUIPage2LogicDisplayFalseProcedure;
import net.mcreator.puzzle_code.network.CustomEffectBlockGUI3ButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class CustomEffectBlockGUI3Screen extends AbstractContainerScreen<CustomEffectBlockGUI3Menu> {
	private final static HashMap<String, Object> guistate = CustomEffectBlockGUI3Menu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	Button button_1;
	Button button_2;
	Button button_3;
	Button button_11;
	Button button_21;
	Button button_31;
	Button button_4;
	ImageButton imagebutton_settings_button;
	ImageButton imagebutton_position_button;

	public CustomEffectBlockGUI3Screen(CustomEffectBlockGUI3Menu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 179;
		this.imageHeight = 98;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("puzzle_code:textures/screens/custom_effect_block_gui_3.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		if (EffectBlockGUIPage2LogicDisplayTrueProcedure.execute(world, x, y, z)) {
			guiGraphics.blit(ResourceLocation.parse("puzzle_code:textures/screens/logic_true.png"), this.leftPos + 122, this.topPos + 50, 0, 0, 48, 20, 48, 20);
		}
		if (EffectBlockGUIPage2LogicDisplayFalseProcedure.execute(world, x, y, z)) {
			guiGraphics.blit(ResourceLocation.parse("puzzle_code:textures/screens/logic_false.png"), this.leftPos + 122, this.topPos + 50, 0, 0, 48, 20, 48, 20);
		}
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font,

				EffectBlockGUIPage2TextProcedure.execute(world, x, y, z), 10, 32, -12829636, false);
		if (EffectBlockGUIPage2ValueDisplayConditionProcedure.execute(world, x, y, z))
			guiGraphics.drawString(this.font,

					ReturnRangeProcedure.execute(world, x, y, z), 58, 54, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		button_1 = Button.builder(Component.translatable("gui.puzzle_code.custom_effect_block_gui_3.button_1"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new CustomEffectBlockGUI3ButtonMessage(0, x, y, z));
				CustomEffectBlockGUI3ButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 10, this.topPos + 9, 18, 20).build();
		guistate.put("button:button_1", button_1);
		this.addRenderableWidget(button_1);
		button_2 = Button.builder(Component.translatable("gui.puzzle_code.custom_effect_block_gui_3.button_2"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new CustomEffectBlockGUI3ButtonMessage(1, x, y, z));
				CustomEffectBlockGUI3ButtonMessage.handleButtonAction(entity, 1, x, y, z);
			}
		}).bounds(this.leftPos + 78, this.topPos + 9, 18, 20).build();
		guistate.put("button:button_2", button_2);
		this.addRenderableWidget(button_2);
		button_3 = Button.builder(Component.translatable("gui.puzzle_code.custom_effect_block_gui_3.button_3"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new CustomEffectBlockGUI3ButtonMessage(2, x, y, z));
				CustomEffectBlockGUI3ButtonMessage.handleButtonAction(entity, 2, x, y, z);
			}
		}).bounds(this.leftPos + 150, this.topPos + 9, 18, 20).build();
		guistate.put("button:button_3", button_3);
		this.addRenderableWidget(button_3);
		button_11 = Button.builder(Component.translatable("gui.puzzle_code.custom_effect_block_gui_3.button_11"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new CustomEffectBlockGUI3ButtonMessage(3, x, y, z));
				CustomEffectBlockGUI3ButtonMessage.handleButtonAction(entity, 3, x, y, z);
			}
		}).bounds(this.leftPos + 10, this.topPos + 72, 20, 20).build();
		guistate.put("button:button_11", button_11);
		this.addRenderableWidget(button_11);
		button_21 = Button.builder(Component.translatable("gui.puzzle_code.custom_effect_block_gui_3.button_21"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new CustomEffectBlockGUI3ButtonMessage(4, x, y, z));
				CustomEffectBlockGUI3ButtonMessage.handleButtonAction(entity, 4, x, y, z);
			}
		}).bounds(this.leftPos + 54, this.topPos + 72, 20, 20).build();
		guistate.put("button:button_21", button_21);
		this.addRenderableWidget(button_21);
		button_31 = Button.builder(Component.translatable("gui.puzzle_code.custom_effect_block_gui_3.button_31"), e -> {
		}).bounds(this.leftPos + 102, this.topPos + 72, 20, 20).build();
		guistate.put("button:button_31", button_31);
		this.addRenderableWidget(button_31);
		button_4 = Button.builder(Component.translatable("gui.puzzle_code.custom_effect_block_gui_3.button_4"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new CustomEffectBlockGUI3ButtonMessage(6, x, y, z));
				CustomEffectBlockGUI3ButtonMessage.handleButtonAction(entity, 6, x, y, z);
			}
		}).bounds(this.leftPos + 150, this.topPos + 72, 20, 20).build();
		guistate.put("button:button_4", button_4);
		this.addRenderableWidget(button_4);
		imagebutton_settings_button = new ImageButton(this.leftPos + 34, this.topPos + 50, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/settings_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/settings_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new CustomEffectBlockGUI3ButtonMessage(7, x, y, z));
						CustomEffectBlockGUI3ButtonMessage.handleButtonAction(entity, 7, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_settings_button", imagebutton_settings_button);
		this.addRenderableWidget(imagebutton_settings_button);
		imagebutton_position_button = new ImageButton(this.leftPos + 10, this.topPos + 50, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/position_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/position_button_hovered.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new CustomEffectBlockGUI3ButtonMessage(8, x, y, z));
						CustomEffectBlockGUI3ButtonMessage.handleButtonAction(entity, 8, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_position_button", imagebutton_position_button);
		this.addRenderableWidget(imagebutton_position_button);
	}
}
